import { LogLevel } from './log-level.enum';
export default abstract class Logger<S> {
    protected service: S;
    private console;
    protected static toTag(str: string): string;
    protected callsCount: number;
    protected logLevel: LogLevel;
    private serviceName;
    constructor(service: S, console: Console, logLevel?: LogLevel);
    protected abstract parseFuncInput(input: any): any;
    protected abstract parseFuncOutput(input: any): any;
    protected callServiceFunction(functionName: string, input: any): Promise<any>;
    protected log(tag: string, callNumber: number, message: string, level: LogLevel): void;
}
