"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const log_level_enum_1 = require("./log-level.enum");
const logger_class_1 = require("./logger.class");
class DynamoAsyncDocumentClientLogger extends logger_class_1.default {
    get(input) {
        return this.callServiceFunction('get', input);
    }
    batchGet(input) {
        return this.callServiceFunction('batchGet', input);
    }
    query(input) {
        const req = Object.assign({
            ReturnConsumedCapacity: this.logLevel >= log_level_enum_1.LogLevel.performance ? 'INDEXES' : 'NONE',
        }, input);
        return this.callServiceFunction('query', req);
    }
    scan(input) {
        return this.callServiceFunction('scan', this.modifyRequestInput(input));
    }
    update(input) {
        return this.callServiceFunction('update', this.modifyRequestInput(input));
    }
    put(input) {
        return this.callServiceFunction('put', input);
    }
    parseFuncInput(input) {
        return input;
    }
    parseFuncOutput(input) {
        return Object.assign({}, input, {
            Item: undefined !== input.Item ? '[Item]' : undefined,
            Items: undefined !== input.Item ? '[Items]' : undefined,
            Responses: undefined !== input.Responses ? '[Responses]' : undefined,
        });
    }
    modifyRequestInput(input) {
        return Object.assign({
            ReturnConsumedCapacity: this.logLevel >= log_level_enum_1.LogLevel.performance ? 'INDEXES' : 'NONE',
        }, input);
    }
}
exports.default = DynamoAsyncDocumentClientLogger;
