"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const log_level_enum_1 = require("./log-level.enum");
const logger_class_1 = require("./logger.class");
class S3AsyncLogger extends logger_class_1.default {
    putObject(input) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.callServiceFunction('putObject', input);
        });
    }
    upload(input) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.callServiceFunction('upload', input);
        });
    }
    getObject(input) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.callServiceFunction('getObject', input);
        });
    }
    copyObject(input) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.callServiceFunction('copyObject', input);
        });
    }
    parseFuncInput(input) {
        return Object.assign({}, input, {
            Body: '[file-body]',
        });
    }
    parseFuncOutput(input) {
        return Object.assign({}, input, {
            Body: '[file-body]',
        });
    }
    callPutPostFunction(functionName, input) {
        return __awaiter(this, void 0, void 0, function* () {
            const callNumber = this.callsCount++;
            const tag = logger_class_1.default.toTag(functionName);
            let response;
            this.log(tag, callNumber, `[CALLED] ${input}`, log_level_enum_1.LogLevel.basic);
            try {
                response = yield this.service[functionName](input);
            }
            catch (err) {
                this.log(tag, callNumber, `[ERROR] ${err.stack}`, log_level_enum_1.LogLevel.error);
                throw err;
            }
            this.log(tag, callNumber, `[OK]`, log_level_enum_1.LogLevel.basic);
            return response;
        });
    }
}
exports.default = S3AsyncLogger;
